---
title: Call Tree
slug: Tools/Performance/Call_Tree
tags:
  - JavaScript
  - Performance
  - memory
---
<div>{{ToolsSidebar}}</div>

<div class="summary">
<p>The Call Tree tells you which JavaScript functions the browser spent the most time in. By analyzing its results, you can find bottlenecks in your code - places where the browser is spending a disproportionately large amount of time.</p>

<p>These bottlenecks are the places where any optimizations you can make will have the biggest impact.</p>
</div>

<p>The Call Tree is a sampling profiler. It periodically samples the state of the JavaScript engine and records the stack for the code executing at the time. Statistically, the number of samples taken in which we were executing a particular function corresponds to the amount of time the browser spent executing it.</p>

<div class="note">
<p>In this article, we'll use the output of a simple program as an example. If you want to get the program to experiment with your profile, you can find it <a href="https://github.com/mdn/performance-scenarios/blob/gh-pages/js-call-tree-1/">here</a>. You can find the specific profile we discuss <a href="https://github.com/mdn/performance-scenarios/blob/gh-pages/js-call-tree-1/profile/call-tree.json">here</a> - just import it to the performance tool to follow along.</p>

<p>There's a short page describing the structure of this program <a href="/en-US/docs/Tools/Performance/Examples/Sorting_algorithms_comparison">here</a>.</p>

<p>Note that we use the same program - the same profile, in fact - in the documentation page for the <a href="/en-US/docs/Tools/Performance/Flame_Chart">Flame Chart</a>.</p>
</div>

<p>The screenshot below shows the output of a program that compares three sorting algorithms - bubble sort, selection sort, and quicksort. To do this, it generates some arrays filled with random integers and sorts them using each algorithm in turn.</p>

<p>We've <a href="/en-US/docs/Tools/Performance/UI_Tour#Zooming_in">zoomed</a> into the part of the recording that shows a long JavaScript marker:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10981/perf-call-tree.png" style="display: block; height: 574px; margin-left: auto; margin-right: auto; width: 1052px;"></p>

<p>The Call Tree presents the results in a table. Each row represents a function in which at least one sample was taken, and the rows are ordered by the number of samples taken while in that function, highest to lowest.</p>

<p><em>Samples</em> is the number of samples that were taken when we were executing this particular function, including its children (the other functions called by this particular function).</p>

<p><em>Total Time</em> is that number translated into milliseconds, based on the total amount of time covered by the selected portion of the recording. These numbers should roughly be the same as the number of samples.</p>

<p><em>Total Cost</em> is that number as a percentage of the total number of samples in the selected portion of the recording.</p>

<p><em>Self Time</em> is calculated as the time spent in that particular function, excluding its children. This comes from the captured stacks where this function is the leafmost function.</p>

<p><em>Self Cost</em> is calculated from <em>Self Time</em> as a percentage of the total number of samples in the selected portion of the recording.</p>

<p>In the current version of the Call Tree, these are the most important columns. Functions with a relatively high <em>Self Cost</em> are good candidates for optimization, either because they take a long time to run, or because they are called very often.</p>

<div class="note">
<p><a href="#Using_an_inverted_aka_Bottom-Up_Call_Tree">The inverted call tree</a> is a good way to focus on these <em>Self Cos</em>t values.</p>
</div>

<p>This screenshot tells us something we probably already knew: Bubble sort is a very inefficient algorithm. We have about six times as many samples in bubble sort as in selection sort, and 13 times as many as in quicksort.</p>

<h2 id="Walking_up_the_call_tree">Walking up the call tree</h2>

<p>Next to each function name is a disclosure arrow: Click that, and you can see the path back up the call tree, from the function in which the sample was taken, to the root. For example, we can expand the entry for <code>bubbleSort()</code>:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10983/perf-call-tree-expanded-bubblesort.png" style="display: block; height: 512px; margin-left: auto; margin-right: auto; width: 1054px;"></p>

<p>So we can see the call graph is like this:</p>

<pre>sortAll()

    -&gt; sort()

        -&gt; bubbleSort()</pre>

<p>Note also that <em>Self Cost</em> for <code>sort()</code> here is 1.45%, and note that this is the same as for the separate entry for <code>sort()</code> later in the list. This is telling us that some samples were taken in <code>sort()</code> itself, rather than in the functions it calls.</p>

<p>Sometimes there's more than one path back from an entry to the top level. Let's expand the entry for <code>swap()</code>:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10985/perf-call-tree-expanded-sawp.png" style="display: block; height: 636px; margin-left: auto; margin-right: auto; width: 1052px;"></p>

<p>There were 253 samples taken inside <code>swap()</code>. But <code>swap()</code> was reached by two different paths: both <code>bubbleSort()</code> and <code>selectionSort()</code> use it. We can also see that 252 of the 253 samples in <code>swap() </code>were taken in the <code>bubbleSort()</code> branch, and only one in the <code>selectionSort()</code> branch.</p>

<p>This result means that bubble sort is even less efficient than we had thought! It can shoulder the blame for another 252 samples, or almost another 10% of the total cost.</p>

<p>With this kind of digging, we can figure out the whole call graph, with associated sample count:</p>

<pre>sortAll()                         //    8

    -&gt; sort()                     //   37

        -&gt; bubbleSort()           // 1345

            -&gt; swap()             //  252

        -&gt; selectionSort()        //  190

            -&gt; swap()             //    1

        -&gt; quickSort()            //  103

            -&gt; partition()        //   12</pre>

<h2 id="Platform_data">Platform data</h2>

<p>You'll also see some rows labeled <em>Gecko</em>, <em>Input &amp; Events</em>, and so on. These represent internal browser calls.</p>

<p>This can be useful information too. If your site is making the browser work hard, this might not show up as samples recorded in your code, but it is still your problem.</p>

<p>In our example, there are 679 samples assigned to <em>Gecko </em>- the second-largest group after <code>bubbleSort()</code>. Let's expand that:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10987/perf-call-tree-expanded-gecko.png" style="display: block; height: 478px; margin-left: auto; margin-right: auto; width: 1050px;"></p>

<p>This result is telling us that 614 of those samples, or about 20% of the total cost, are coming from our <code>sort()</code> call. If we look at the code for <code>sort()</code>, it should be fairly obvious that the high platform data cost is coming from repeated calls to <code>console.log()</code>:</p>

<pre class="brush: js">function sort(unsorted) {
  console.log(bubbleSort(unsorted));
  console.log(selectionSort(unsorted));
  console.log(quickSort(unsorted));
}</pre>

<p>It would certainly be worthwhile considering more efficient ways of implementing this.</p>

<p>One thing to be aware of here is that idle time is classified as <em>Gecko</em>, so parts of your profile where your JavaScript isn't running will contribute <em>Gecko</em> samples. These aren't relevant to the performance of your site.</p>

<div class="note">
<p>By default, the Call Tree doesn't split platform data out into separate functions, because they add a great deal of noise, and the details are not likely to be useful to people not working on Firefox. If you want to see the details, check "Show Gecko Platform Data" in the <a href="/en-US/docs/Tools/Performance/UI_Tour#Toolbar">Settings</a>.</p>
</div>

<h2 id="Using_an_inverted_aka_Bottom-Up_Call_Tree">Using an inverted, aka Bottom-Up, Call Tree</h2>


<p>An inverted call tree reverses the order of all stacks, putting the leafmost function calls at the top. The direct consequence is that this is a view that focuses more on the function's <em>Self Time</em> information. This is a very useful view to find some hot spot in your code.</p>

<p>To display this view, click the gear icon on the right-hand end of the performance tab and select <strong>Invert Call Tree</strong>.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16093/performance_menu_invert_call_tree.png" style="border-style: solid; border-width: 1px; display: block; height: 201px; margin: 0 auto; width: 492px;"></p>

